<?php
/*
Plugin Name: Thumbnails Regeneration
Version: 2.2.0
Description: Regenerate thumbnails
Author: P@t
*/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
define('REGENERATE_THUMBNAILS_PATH' , PHPWG_PLUGINS_PATH . basename(dirname(__FILE__)) . '/');

add_event_handler('loc_begin_element_set_global', 'rg_element_set_global_add_action');
add_event_handler('ws_add_methods', 'add_regenerate_thumbnails_method');

function rg_element_set_global_add_action()
{
  global $template, $conf, $page, $pwg_loaded_plugins;

  load_language('plugin.lang', REGENERATE_THUMBNAILS_PATH);
  include_once(PHPWG_ROOT_PATH.'admin/include/functions_upload.inc.php');

  $template->set_filename('regenerateThumbnails', realpath(REGENERATE_THUMBNAILS_PATH.'element_set_global_action.tpl'));

  if (isset($_GET['regeneratedThumbnail']))
  {
    $template->delete_compiled_templates();
    array_push($page['infos'], sprintf(l10n('%s thumbnails have been regenerated'), $_GET['regeneratedThumbnail']));
  }

  foreach (get_upload_form_config() as $param_shortname => $param)
  {
    $param_name = 'upload_form_'.$param_shortname;
    $form_values[$param_shortname] = $conf[$param_name];
  }

  if (isset($pwg_loaded_plugins['square_thumbnails']))
  {
    load_language('plugin.lang', SQUARE_THUMB_PATH);
    $template->assign(array('SQUARE' => @$conf['upload_form_thumb_square']));
  }

  $template->assign(array(
    'upload_form_settings' => $form_values,
    'all_elements' => $page['cat_elements_id'],
    'redirect_url' => get_root_url().'admin.php?page='.$_GET['page'],
    )
  );

  $template->append('element_set_global_plugins_actions', array(
    'ID' => 'regenerateThumbnails',
    'NAME' => l10n('Regenerate Thumbnails'),
    'CONTENT' => $template->parse('regenerateThumbnails', true),
    )
  );

  $template->set_prefilter('batch_manager_global', 'regenerate_prefilter');
}

function add_regenerate_thumbnails_method($arr)
{
  global $conf;

  $service = &$arr[0];
  $service->addMethod(
    'pwg.images.regenerateThumbnail',
    'ws_images_regenerateThumbnail',
    array(
      'image_id'  => array(),
      'maxwidth'  => array('default'=>$conf['upload_form_thumb_maxwidth']),
      'maxheight' => array('default'=>$conf['upload_form_thumb_maxheight']),
      'quality'   => array('default'=>$conf['upload_form_thumb_quality']),
      'square'    => array('default'=>@$conf['upload_form_thumb_square']),
    ),
    'Regenerate a thumbnail with given arguments.'
  );
}

function ws_images_regenerateThumbnail($params, &$service)
{
  global $conf;

  if (!is_admin())
    return new PwgError(401, 'Access denied');

  $query='
SELECT id, path
FROM '.IMAGES_TABLE.'
WHERE id = '.(int)$params['image_id'].'
;';

  $image = pwg_db_fetch_assoc(pwg_query($query));
  if ($image == null)
    return new PwgError(404, "image_id not found");

  include_once(PHPWG_ROOT_PATH.'admin/include/functions_upload.inc.php');

  if ($params['square'] == 'true' or $params['square'] == 'false')
    $params['square'] = get_boolean($params['square']);
  if (!$params['square'])
    remove_event_handler('upload_thumbnail_resize', 'upload_square_resize', 40);
  
  trigger_event(
    'upload_thumbnail_resize',
    false,
    $image['path'],
    file_path_for_type($image['path'], 'thumb'),
    $params['maxwidth'],
    $params['maxheight'],
    $params['quality'],
    true
    );

  return true;
}

function regenerate_prefilter($content, $smarty)
{
  return str_replace('{$thumbnail.TN_SRC}', '{$thumbnail.TN_SRC}?rand='.md5(uniqid(rand(), true)), $content);
}

?>